Index: /LMDZ5/branches/testing/libf/phylmd/cpl_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cpl_mod.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/cpl_mod.F90	(revision 2408)
@@ -24,6 +24,5 @@
   USE oasis
   USE write_field_phy
-  USE control_mod
-
+  USE time_phylmdz_mod, ONLY: day_step_phy
   
 ! Global attributes
@@ -102,8 +101,7 @@
     USE surface_data
     USE indice_sol_mod
-
-    INCLUDE "dimensions.h"
-    INCLUDE "temps.h"
-    INCLUDE "iniprint.h"
+    USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat
+    USE time_phylmdz_mod, ONLY: annee_ref, day_ini, itau_phy, itaufin_phy
+    USE print_control_mod, ONLY: lunout
 
 ! Input arguments
@@ -121,5 +119,5 @@
     INTEGER                           :: npas ! only for OASIS2
     REAL                              :: zjulian
-    REAL, DIMENSION(iim,jjm+1)        :: zx_lon, zx_lat
+    REAL, DIMENSION(nbp_lon,nbp_lat)  :: zx_lon, zx_lat
     CHARACTER(len = 20)               :: modname = 'cpl_init'
     CHARACTER(len = 80)               :: abort_message
@@ -131,5 +129,5 @@
 !*************************************************************************************
      
-    npas = itaufin/ iphysiq
+    npas = itaufin_phy
 !    nexca = 86400 / dtime
     nexca = t_coupl / dtime
@@ -172,25 +170,25 @@
     ALLOCATE(cpl_taumod(klon,2), stat = error)
     sum_error = sum_error + error
-    ALLOCATE(cpl_rriv2D(iim,jj_nb), stat=error)
-    sum_error = sum_error + error
-    ALLOCATE(cpl_rcoa2D(iim,jj_nb), stat=error)
-    sum_error = sum_error + error
-    ALLOCATE(cpl_rlic2D(iim,jj_nb), stat=error)
-    sum_error = sum_error + error
-    ALLOCATE(read_sst(iim, jj_nb), stat = error)
-    sum_error = sum_error + error
-    ALLOCATE(read_sic(iim, jj_nb), stat = error)
-    sum_error = sum_error + error
-    ALLOCATE(read_sit(iim, jj_nb), stat = error)
-    sum_error = sum_error + error
-    ALLOCATE(read_alb_sic(iim, jj_nb), stat = error)
-    sum_error = sum_error + error
-    ALLOCATE(read_u0(iim, jj_nb), stat = error)
-    sum_error = sum_error + error
-    ALLOCATE(read_v0(iim, jj_nb), stat = error)
+    ALLOCATE(cpl_rriv2D(nbp_lon,jj_nb), stat=error)
+    sum_error = sum_error + error
+    ALLOCATE(cpl_rcoa2D(nbp_lon,jj_nb), stat=error)
+    sum_error = sum_error + error
+    ALLOCATE(cpl_rlic2D(nbp_lon,jj_nb), stat=error)
+    sum_error = sum_error + error
+    ALLOCATE(read_sst(nbp_lon, jj_nb), stat = error)
+    sum_error = sum_error + error
+    ALLOCATE(read_sic(nbp_lon, jj_nb), stat = error)
+    sum_error = sum_error + error
+    ALLOCATE(read_sit(nbp_lon, jj_nb), stat = error)
+    sum_error = sum_error + error
+    ALLOCATE(read_alb_sic(nbp_lon, jj_nb), stat = error)
+    sum_error = sum_error + error
+    ALLOCATE(read_u0(nbp_lon, jj_nb), stat = error)
+    sum_error = sum_error + error
+    ALLOCATE(read_v0(nbp_lon, jj_nb), stat = error)
     sum_error = sum_error + error
 
     IF (carbon_cycle_cpl) THEN
-       ALLOCATE(read_co2(iim, jj_nb), stat = error)
+       ALLOCATE(read_co2(nbp_lon, jj_nb), stat = error)
        sum_error = sum_error + error
        ALLOCATE(cpl_atm_co2(klon,2), stat = error)
@@ -204,5 +202,5 @@
     IF (sum_error /= 0) THEN
        abort_message='Pb allocation variables couplees'
-       CALL abort_gcm(modname,abort_message,1)
+       CALL abort_physic(modname,abort_message,1)
     ENDIF
 !*************************************************************************************
@@ -230,26 +228,26 @@
        idayref = day_ini
        CALL ymds2ju(annee_ref, 1, idayref, 0.0, zjulian)
-       CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlon,zx_lon)
-       DO i = 1, iim
+       CALL gr_fi_ecrit(1,klon,nbp_lon,nbp_lat,rlon,zx_lon)
+       DO i = 1, nbp_lon
           zx_lon(i,1) = rlon(i+1)
-          zx_lon(i,jjm+1) = rlon(i+1)
+          zx_lon(i,nbp_lat) = rlon(i+1)
        ENDDO
-       CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlat,zx_lat)
+       CALL gr_fi_ecrit(1,klon,nbp_lon,nbp_lat,rlat,zx_lat)
        clintocplnam="cpl_atm_tauflx"
-       CALL histbeg(clintocplnam, iim,zx_lon(:,1),jjm+1,zx_lat(1,:),&
-            1,iim,1,jjm+1, itau_phy,zjulian,dtime,nhoridct,nidct) 
+       CALL histbeg(clintocplnam,nbp_lon,zx_lon(:,1),nbp_lat,zx_lat(1,:),&
+            1,nbp_lon,1,nbp_lat, itau_phy,zjulian,dtime,nhoridct,nidct) 
 ! no vertical axis
        CALL histdef(nidct, 'tauxe','tauxe', &
-            "-",iim, jjm+1, nhoridct, 1, 1, 1, -99, 32, "inst", dtime,dtime)
+            "-",nbp_lon,nbp_lat, nhoridct, 1, 1, 1, -99, 32, "inst", dtime,dtime)
        CALL histdef(nidct, 'tauyn','tauyn', &
-            "-",iim, jjm+1, nhoridct, 1, 1, 1, -99, 32, "inst", dtime,dtime)
+            "-",nbp_lon,nbp_lat, nhoridct, 1, 1, 1, -99, 32, "inst", dtime,dtime)
        CALL histdef(nidct, 'tmp_lon','tmp_lon', &
-            "-",iim, jjm+1, nhoridct, 1, 1, 1, -99, 32, "inst", dtime,dtime)
+            "-",nbp_lon,nbp_lat, nhoridct, 1, 1, 1, -99, 32, "inst", dtime,dtime)
        CALL histdef(nidct, 'tmp_lat','tmp_lat', &
-            "-",iim, jjm+1, nhoridct, 1, 1, 1, -99, 32, "inst", dtime,dtime)
+            "-",nbp_lon,nbp_lat, nhoridct, 1, 1, 1, -99, 32, "inst", dtime,dtime)
        DO jf=1,maxsend
          IF (infosend(i)%action) THEN
              CALL histdef(nidct, infosend(i)%name ,infosend(i)%name , &
-                "-",iim, jjm+1, nhoridct, 1, 1, 1, -99, 32, "inst", dtime,dtime)
+                "-",nbp_lon,nbp_lat,nhoridct,1,1,1,-99,32,"inst",dtime,dtime)
          ENDIF
        END DO
@@ -258,5 +256,5 @@
        
        clfromcplnam="cpl_atm_sst"
-       CALL histbeg(clfromcplnam, iim,zx_lon(:,1),jjm+1,zx_lat(1,:),1,iim,1,jjm+1, &
+       CALL histbeg(clfromcplnam,nbp_lon,zx_lon(:,1),nbp_lat,zx_lat(1,:),1,nbp_lon,1,nbp_lat, &
             0,zjulian,dtime,nhoridcs,nidcs) 
 ! no vertical axis
@@ -264,5 +262,5 @@
          IF (inforecv(i)%action) THEN
              CALL histdef(nidcs,inforecv(i)%name ,inforecv(i)%name , &
-                "-",iim, jjm+1, nhoridcs, 1, 1, 1, -99, 32, "inst", dtime,dtime)
+                "-",nbp_lon,nbp_lat,nhoridcs,1,1,1,-99,32,"inst",dtime,dtime)
          ENDIF
        END DO
@@ -279,5 +277,5 @@
     IF (carbon_cycle_cpl .AND. version_ocean=='opa8') THEN
        abort_message='carbon_cycle_cpl does not work with opa8'
-       CALL abort_gcm(modname,abort_message,1)
+       CALL abort_physic(modname,abort_message,1)
     END IF
 
@@ -297,9 +295,8 @@
     USE carbon_cycle_mod, ONLY : carbon_cycle_cpl
     USE indice_sol_mod
-
-    INCLUDE "temps.h"
-    INCLUDE "iniprint.h"
+    USE time_phylmdz_mod, ONLY: start_time, itau_phy
+    USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat
+
     INCLUDE "YOMCST.h"
-    INCLUDE "dimensions.h"
 
 ! Arguments
@@ -314,13 +311,13 @@
     INTEGER                                 :: j, i, time_sec
     INTEGER                                 :: itau_w
-    INTEGER, DIMENSION(iim*(jjm+1))         :: ndexcs
+    INTEGER, DIMENSION(nbp_lon*nbp_lat)     :: ndexcs
     CHARACTER(len = 20)                     :: modname = 'cpl_receive_frac'
     CHARACTER(len = 80)                     :: abort_message
     REAL, DIMENSION(klon)                   :: read_sic1D
-    REAL, DIMENSION(iim,jj_nb,maxrecv)      :: tab_read_flds
+    REAL, DIMENSION(nbp_lon,jj_nb,maxrecv)      :: tab_read_flds
     REAL, DIMENSION(klon,nbsrf)             :: pctsrf_old
     REAL, DIMENSION(klon_mpi)               :: rlon_mpi, rlat_mpi
-    REAL, DIMENSION(iim, jj_nb)             :: tmp_lon, tmp_lat
-    REAL, DIMENSION(iim, jj_nb)             :: tmp_r0
+    REAL, DIMENSION(nbp_lon,jj_nb)             :: tmp_lon, tmp_lat
+    REAL, DIMENSION(nbp_lon,jj_nb)             :: tmp_r0
 
 !*************************************************************************************
@@ -346,8 +343,8 @@
        IF (is_sequential) THEN
           ndexcs(:) = 0
-          itau_w = itau_phy + itime + start_time * day_step / iphysiq
+          itau_w = itau_phy + itime + start_time * day_step_phy
           DO i = 1, maxrecv
             IF (inforecv(i)%action) THEN
-                CALL histwrite(nidcs,inforecv(i)%name,itau_w,tab_read_flds(:,:,i),iim*(jjm+1),ndexcs)
+                CALL histwrite(nidcs,inforecv(i)%name,itau_w,tab_read_flds(:,:,i),nbp_lon*(nbp_lat),ndexcs)
             ENDIF
           END DO
@@ -374,5 +371,5 @@
 ! Transform the currents from cartesian to spheric coordinates
 ! tmp_r0 should be zero
-          CALL geo2atm(iim, jj_nb, tab_read_flds(:,:,idr_curenx), &
+          CALL geo2atm(nbp_lon, jj_nb, tab_read_flds(:,:,idr_curenx), &
              tab_read_flds(:,:,idr_cureny), tab_read_flds(:,:,idr_curenz), &
                tmp_lon, tmp_lat, &
@@ -543,5 +540,5 @@
     USE carbon_cycle_mod, ONLY : carbon_cycle_cpl, co2_send
     USE indice_sol_mod
-    INCLUDE "dimensions.h"
+    USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat
 
 ! Input arguments
@@ -636,31 +633,31 @@
        IF (.NOT. ALLOCATED(cpl_sols2D)) THEN
           sum_error = 0
-          ALLOCATE(cpl_sols2D(iim,jj_nb,2), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_nsol2D(iim,jj_nb,2), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_rain2D(iim,jj_nb,2), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_snow2D(iim,jj_nb,2), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_evap2D(iim,jj_nb,2), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_tsol2D(iim,jj_nb,2), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_fder2D(iim,jj_nb,2), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_albe2D(iim,jj_nb,2), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_taux2D(iim,jj_nb,2), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_tauy2D(iim,jj_nb,2), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_windsp2D(iim,jj_nb), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_taumod2D(iim,jj_nb,2), stat=error)
+          ALLOCATE(cpl_sols2D(nbp_lon,jj_nb,2), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_nsol2D(nbp_lon,jj_nb,2), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_rain2D(nbp_lon,jj_nb,2), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_snow2D(nbp_lon,jj_nb,2), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_evap2D(nbp_lon,jj_nb,2), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_tsol2D(nbp_lon,jj_nb,2), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_fder2D(nbp_lon,jj_nb,2), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_albe2D(nbp_lon,jj_nb,2), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_taux2D(nbp_lon,jj_nb,2), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_tauy2D(nbp_lon,jj_nb,2), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_windsp2D(nbp_lon,jj_nb), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_taumod2D(nbp_lon,jj_nb,2), stat=error)
           sum_error = sum_error + error
           
           IF (carbon_cycle_cpl) THEN
-             ALLOCATE(cpl_atm_co22D(iim,jj_nb), stat=error)
+             ALLOCATE(cpl_atm_co22D(nbp_lon,jj_nb), stat=error)
              sum_error = sum_error + error
           END IF
@@ -668,5 +665,5 @@
           IF (sum_error /= 0) THEN
              abort_message='Pb allocation variables couplees pour l''ecriture'
-             CALL abort_gcm(modname,abort_message,1)
+             CALL abort_physic(modname,abort_message,1)
           ENDIF
        ENDIF
@@ -734,5 +731,5 @@
     USE carbon_cycle_mod, ONLY : carbon_cycle_cpl
     USE indice_sol_mod
-    INCLUDE "dimensions.h"
+    USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat
 
 ! Input arguments
@@ -821,31 +818,31 @@
        IF (.NOT. ALLOCATED(cpl_sols2D)) THEN
           sum_error = 0
-          ALLOCATE(cpl_sols2D(iim,jj_nb,2), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_nsol2D(iim,jj_nb,2), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_rain2D(iim,jj_nb,2), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_snow2D(iim,jj_nb,2), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_evap2D(iim,jj_nb,2), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_tsol2D(iim,jj_nb,2), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_fder2D(iim,jj_nb,2), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_albe2D(iim,jj_nb,2), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_taux2D(iim,jj_nb,2), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_tauy2D(iim,jj_nb,2), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_windsp2D(iim,jj_nb), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_taumod2D(iim,jj_nb,2), stat=error)
+          ALLOCATE(cpl_sols2D(nbp_lon,jj_nb,2), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_nsol2D(nbp_lon,jj_nb,2), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_rain2D(nbp_lon,jj_nb,2), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_snow2D(nbp_lon,jj_nb,2), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_evap2D(nbp_lon,jj_nb,2), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_tsol2D(nbp_lon,jj_nb,2), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_fder2D(nbp_lon,jj_nb,2), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_albe2D(nbp_lon,jj_nb,2), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_taux2D(nbp_lon,jj_nb,2), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_tauy2D(nbp_lon,jj_nb,2), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_windsp2D(nbp_lon,jj_nb), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_taumod2D(nbp_lon,jj_nb,2), stat=error)
           sum_error = sum_error + error
 
           IF (carbon_cycle_cpl) THEN
-             ALLOCATE(cpl_atm_co22D(iim,jj_nb), stat=error)
+             ALLOCATE(cpl_atm_co22D(nbp_lon,jj_nb), stat=error)
              sum_error = sum_error + error
           END IF
@@ -853,5 +850,5 @@
           IF (sum_error /= 0) THEN
              abort_message='Pb allocation variables couplees pour l''ecriture'
-             CALL abort_gcm(modname,abort_message,1)
+             CALL abort_physic(modname,abort_message,1)
           ENDIF
        ENDIF
@@ -914,5 +911,5 @@
 ! (it is done in cpl_send_seaice_fields).
 !
-    INCLUDE "dimensions.h"
+    USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat
 
 ! Input arguments
@@ -926,6 +923,6 @@
 ! Local variables
 !*************************************************************************************
-    REAL, DIMENSION(iim,jj_nb)             :: rriv2D
-    REAL, DIMENSION(iim,jj_nb)             :: rcoa2D
+    REAL, DIMENSION(nbp_lon,jj_nb)             :: rriv2D
+    REAL, DIMENSION(nbp_lon,jj_nb)             :: rcoa2D
 
 !*************************************************************************************
@@ -973,5 +970,5 @@
 !
 
-    INCLUDE "dimensions.h"
+    USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat
 
 ! Input varibales
@@ -984,5 +981,5 @@
 ! Local varibales
 !*************************************************************************************
-    REAL, DIMENSION(iim,jj_nb)             :: rlic2D
+    REAL, DIMENSION(nbp_lon,jj_nb)             :: rlic2D
 
 !*************************************************************************************
@@ -1028,9 +1025,8 @@
     USE carbon_cycle_mod, ONLY : carbon_cycle_cpl
     USE indice_sol_mod
+    USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat
+    USE time_phylmdz_mod, ONLY: start_time, itau_phy
 ! Some includes
-!*************************************************************************************
-    INCLUDE "temps.h"
-    INCLUDE "dimensions.h"
-    
+!    
 ! Input arguments
 !*************************************************************************************
@@ -1046,18 +1042,18 @@
     INTEGER                                              :: itau_w
     INTEGER                                              :: time_sec
-    INTEGER, DIMENSION(iim*(jjm+1))                      :: ndexct
+    INTEGER, DIMENSION(nbp_lon*(nbp_lat))                      :: ndexct
     REAL                                                 :: Up, Down
-    REAL, DIMENSION(iim, jj_nb)                          :: tmp_lon, tmp_lat
-    REAL, DIMENSION(iim, jj_nb, 4)                       :: pctsrf2D
-    REAL, DIMENSION(iim, jj_nb)                          :: deno
+    REAL, DIMENSION(nbp_lon, jj_nb)                          :: tmp_lon, tmp_lat
+    REAL, DIMENSION(nbp_lon, jj_nb, 4)                       :: pctsrf2D
+    REAL, DIMENSION(nbp_lon, jj_nb)                          :: deno
     CHARACTER(len = 20)                                  :: modname = 'cpl_send_all'
     CHARACTER(len = 80)                                  :: abort_message
    
 ! Variables with fields to coupler
-    REAL, DIMENSION(iim, jj_nb)                          :: tmp_taux
-    REAL, DIMENSION(iim, jj_nb)                          :: tmp_tauy
-    REAL, DIMENSION(iim, jj_nb)                          :: tmp_calv
+    REAL, DIMENSION(nbp_lon, jj_nb)                          :: tmp_taux
+    REAL, DIMENSION(nbp_lon, jj_nb)                          :: tmp_tauy
+    REAL, DIMENSION(nbp_lon, jj_nb)                          :: tmp_calv
 ! Table with all fields to send to coupler
-    REAL, DIMENSION(iim, jj_nb, maxsend)                 :: tab_flds
+    REAL, DIMENSION(nbp_lon, jj_nb, maxsend)                 :: tab_flds
     REAL, DIMENSION(klon_mpi)                            :: rlon_mpi, rlat_mpi
 
@@ -1113,6 +1109,6 @@
 
       DO j = 1, jj_nb
-         tmp_calv(:,j) = DOT_PRODUCT (cpl_rlic2D(1:iim,j), &
-              pctsrf2D(1:iim,j,is_lic)) / REAL(iim)
+         tmp_calv(:,j) = DOT_PRODUCT (cpl_rlic2D(1:nbp_lon,j), &
+              pctsrf2D(1:nbp_lon,j,is_lic)) / REAL(nbp_lon)
       ENDDO
     
@@ -1134,9 +1130,9 @@
          
          IF (.NOT. is_north_pole .AND. ii_begin /=1) THEN
-            Up=Up+tmp_calv(iim,1)
+            Up=Up+tmp_calv(nbp_lon,1)
             tmp_calv(:,1)=Up
          ENDIF
          
-         IF (.NOT. is_south_pole .AND. ii_end /= iim) THEN
+         IF (.NOT. is_south_pole .AND. ii_end /= nbp_lon) THEN
             Down=Down+tmp_calv(1,jj_nb)
             tmp_calv(:,jj_nb)=Down	 
@@ -1227,5 +1223,5 @@
     IF (is_sequential) THEN
        IF (is_north_pole) tmp_lon(:,1)     = tmp_lon(:,2)
-       IF (is_south_pole) tmp_lon(:,jjm+1) = tmp_lon(:,jjm)
+       IF (is_south_pole) tmp_lon(:,nbp_lat) = tmp_lon(:,nbp_lat-1)
     ENDIF
       
@@ -1233,9 +1229,9 @@
     IF (is_sequential) THEN
        ndexct(:) = 0
-       itau_w = itau_phy + itime + start_time * day_step / iphysiq
-       CALL histwrite(nidct,'tauxe',itau_w,tmp_taux,iim*(jjm+1),ndexct)
-       CALL histwrite(nidct,'tauyn',itau_w,tmp_tauy,iim*(jjm+1),ndexct)
-       CALL histwrite(nidct,'tmp_lon',itau_w,tmp_lon,iim*(jjm+1),ndexct)
-       CALL histwrite(nidct,'tmp_lat',itau_w,tmp_lat,iim*(jjm+1),ndexct)
+       itau_w = itau_phy + itime + start_time * day_step_phy
+       CALL histwrite(nidct,'tauxe',itau_w,tmp_taux,nbp_lon*(nbp_lat),ndexct)
+       CALL histwrite(nidct,'tauyn',itau_w,tmp_tauy,nbp_lon*(nbp_lat),ndexct)
+       CALL histwrite(nidct,'tmp_lon',itau_w,tmp_lon,nbp_lon*(nbp_lat),ndexct)
+       CALL histwrite(nidct,'tmp_lat',itau_w,tmp_lat,nbp_lon*(nbp_lat),ndexct)
     ENDIF
 
@@ -1243,5 +1239,5 @@
 ! cartesian 3D coordinates 
 !$OMP MASTER
-    CALL atm2geo (iim, jj_nb, tmp_taux, tmp_tauy, tmp_lon, tmp_lat, &
+    CALL atm2geo (nbp_lon, jj_nb, tmp_taux, tmp_tauy, tmp_lon, tmp_lat, &
          tab_flds(:,:,ids_tauxxu), tab_flds(:,:,ids_tauyyu), tab_flds(:,:,ids_tauzzu) )
     
@@ -1258,5 +1254,5 @@
         DO j=1,maxsend
           IF (infosend(j)%action) CALL histwrite(nidct,infosend(j)%name, itau_w, &
-             tab_flds(:,:,j),iim*(jjm+1),ndexct)
+             tab_flds(:,:,j),nbp_lon*(nbp_lat),ndexct)
         ENDDO
     ENDIF
@@ -1291,5 +1287,5 @@
     IF (sum_error /= 0) THEN
        abort_message='Pb in deallocation of cpl_xxxx2D coupling variables'
-       CALL abort_gcm(modname,abort_message,1)
+       CALL abort_physic(modname,abort_message,1)
     ENDIF
     
@@ -1312,9 +1308,9 @@
 !   champ_out    champ sur la grille 'gatherd'
 !
-    INCLUDE "dimensions.h"
+    USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat
 
 ! Input
     INTEGER, INTENT(IN)                       :: knon
-    REAL, DIMENSION(iim,jj_nb), INTENT(IN)    :: champ_in
+    REAL, DIMENSION(nbp_lon,jj_nb), INTENT(IN)    :: champ_in
     INTEGER, DIMENSION(klon), INTENT(IN)      :: knindex
 
@@ -1331,5 +1327,5 @@
     
 
-! Transform from 2 dimensions (iim,jj_nb) to 1 dimension (klon)
+! Transform from 2 dimensions (nbp_lon,jj_nb) to 1 dimension (klon)
 !$OMP MASTER 
     CALL Grid2Dto1D_mpi(champ_in,temp_mpi)
@@ -1361,5 +1357,5 @@
 !   champ_out    champ sur la grille 2D
 !
-    INCLUDE "dimensions.h"
+    USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat
     
 ! Input arguments
@@ -1371,5 +1367,5 @@
 ! Output arguments
 !*************************************************************************************
-    REAL, DIMENSION(iim,jj_nb), INTENT(OUT) :: champ_out
+    REAL, DIMENSION(nbp_lon,jj_nb), INTENT(OUT) :: champ_out
 
 ! Local variables
@@ -1387,5 +1383,5 @@
     ENDDO
 
-! Transform from 1 dimension (klon) to 2 dimensions (iim,jj_nb)
+! Transform from 1 dimension (klon) to 2 dimensions (nbp_lon,jj_nb)
     CALL gather_omp(temp_omp,temp_mpi)
 
Index: /LMDZ5/branches/testing/libf/phylmd/ctstar.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/ctstar.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/phylmd/ctstar.F90	(revision 2408)
@@ -0,0 +1,128 @@
+SUBROUTINE CTSTAR(KPROMA,KSTART,KPROF,PTB,PRESBH,PRESBF,POROG,PTSTAR,PT0)
+
+!**** *CTSTAR* - COMPUTES STANDARD SURFACE TEMPERATURE
+!                              AND SURFACE TEMPERATURE.
+
+!     PURPOSE.
+!     --------
+
+!           COMPUTES THE STANDARD SURFACE TEMPERATURE AND THE SURFACE
+!           TEMPERATURE TO BE USED FOR EXTRAPOLATIONS OF TEMPERATURE
+!           AND GEOPOTENTIEL.
+
+!**   INTERFACE.
+!     ----------
+!        *CALL* *CTSTAR(..)*
+
+!        EXPLICIT ARGUMENTS
+!        --------------------
+
+!        KPROMA         - HORIZONTAL DIMENSIONS.             (INPUT)
+!        KSTART         - START OF WORK                      (INPUT)
+!        KPROF          - DEPTH OF WORK                      (INPUT)
+
+!        PTB(KPROMA)    - TEMPERATURE AT NFLEVG-1             (INPUT)
+!        PRESBH(KPROMA) - LOWEST MODEL HALF LEVEL PRESSURES  (INPUT)
+
+!        PRESBF(KPROMA) - PRESSURE AT NFLEVG-1                (INPUT)
+!        POROG(KPROMA)  - MODEL ORGRAPHY                     (INPUT)
+
+
+!        PTSTAR(KPROMA) - SURFACE TEMPERATURE                (OUTPUT)
+
+!        PT0(KPROMA)    - STANDARD SURFACE TEMPERATURE       (OUTPUT)
+
+!        IMPLICIT ARGUMENTS :    CONSTANTS FROM YOMSTA,YOMCST.
+!        --------------------
+
+!     METHOD.
+!     -------
+!        SEE DOCUMENTATION
+
+!     EXTERNALS.   NONE.
+!     ----------
+
+!     REFERENCE.
+!     ----------
+!        ECMWF Research Department documentation of the IFS
+
+!     AUTHOR.
+!     -------
+!        MATS HAMRUD AND PHILIPPE COURTIER  *ECMWF*
+
+!     MODIFICATIONS.
+!     --------------
+!        ORIGINAL : 89-05-02
+
+!      Modification : 93-06-01 M.Hamrud (Comment only, now T from NFLEVG-1)
+!        M.Hamrud      01-Oct-2003 CY28 Cleaning
+
+!     ------------------------------------------------------------------
+
+!USE PARKIND1 
+!<http://intra.cnrm.meteo.fr/eac/ARPCLI5.2/doci/code/arpcli5.2/xrd/module/parkind1.F90.php#parkind1>  ,ONLY : JPIM     ,JPRB
+!USE YOMHOOK 
+!<http://intra.cnrm.meteo.fr/eac/ARPCLI5.2/doci/code/arpcli5.2/xrd/module/yomhook.F90.php#yomhook>   ,ONLY : LHOOK,   DR_HOOK
+
+!USE YOMCST, ONLY : RG, RD 
+!<http://intra.cnrm.meteo.fr/eac/ARPCLI5.2/doci/code/arpcli5.2/arp/module/yomcst.F90.php#yomcst>   , ONLY :  RG
+
+!<http://intra.cnrm.meteo.fr/eac/ARPCLI5.2/doci/code/arpcli5.2/xrd/support/rg.F.php#rg>       ,RD
+!USE YOMSTA 
+!<http://intra.cnrm.meteo.fr/eac/ARPCLI5.2/doci/code/arpcli5.2/arp/module/yomsta.F90.php#yomsta>   , ONLY : RDTDZ1
+
+IMPLICIT NONE
+
+include "YOMCST.h"
+!IM INTEGER(KIND=JPIM),INTENT(IN)    :: KPROMA
+!IM INTEGER(KIND=JPIM),INTENT(IN)    :: KSTART
+!IM INTEGER(KIND=JPIM),INTENT(IN)    :: KPROF
+INTEGER,INTENT(IN)    :: KPROMA
+INTEGER,INTENT(IN)    :: KSTART
+INTEGER,INTENT(IN)    :: KPROF
+!IM REAL(KIND=JPRB)   ,INTENT(IN)    :: PTB(KPROMA)
+REAL   ,INTENT(IN)    :: PTB(KPROMA)
+!IM REAL(KIND=JPRB)   ,INTENT(IN)    :: PRESBH(KPROMA)
+REAL   ,INTENT(IN)    :: PRESBH(KPROMA)
+!IM REAL(KIND=JPRB)   ,INTENT(IN)    :: PRESBF(KPROMA)
+REAL   ,INTENT(IN)    :: PRESBF(KPROMA)
+!IM REAL(KIND=JPRB)   ,INTENT(IN)    :: POROG(KPROMA)
+REAL   ,INTENT(IN)    :: POROG(KPROMA)
+!IM REAL(KIND=JPRB)   ,INTENT(OUT)   :: PTSTAR(KPROMA)
+REAL   ,INTENT(OUT)   :: PTSTAR(KPROMA)
+!IM REAL(KIND=JPRB)   ,INTENT(OUT)   :: PT0(KPROMA)
+REAL   ,INTENT(OUT)   :: PT0(KPROMA)
+!IM INTEGER(KIND=JPIM) :: JL
+INTEGER :: JL
+
+!IM REAL(KIND=JPRB) :: ZALPHA, ZDTDZSG
+REAL :: ZALPHA, ZDTDZSG
+!IM REAL(KIND=JPRB) :: ZHOOK_HANDLE
+REAL :: ZHOOK_HANDLE
+!IM beg
+REAL, PARAMETER                  :: RDTDZ1=-0.0065 !or USE YOMSTA
+!IM end
+
+!     ------------------------------------------------------------------
+
+!*       1.    COMPUTES SURFACE TEMPERATURE
+!*             THEN STANDARD SURFACE TEMPERATURE.
+
+!IF (LHOOK) CALL DR_HOOK('CTSTAR',0,ZHOOK_HANDLE)
+ZDTDZSG=-RDTDZ1/RG 
+!<http://intra.cnrm.meteo.fr/eac/ARPCLI5.2/doci/code/arpcli5.2/xrd/support/rg.F.php#rg>
+ZALPHA=ZDTDZSG*RD
+DO JL=KSTART,KPROF
+
+   !IM PTSTAR(JL)=PTB(JL)*(1.0_JPRB+ZALPHA*(PRESBH(JL)/PRESBF(JL)-1.0_JPRB))
+   PTSTAR(JL)=PTB(JL)*(1.0+ZALPHA*(PRESBH(JL)/PRESBF(JL)-1.0))
+   PT0(JL)=PTSTAR(JL)+ZDTDZSG*POROG(JL)
+!  print*,'cstar JL ptb zalpha PRESBH PRESBF ptstar' &
+!  ,JL,PTB(JL),ZALPHA,PRESBH(JL),PRESBF(JL),PTSTAR(JL)
+ENDDO
+
+
+!     ------------------------------------------------------------------
+
+!IF (LHOOK) CALL DR_HOOK('CTSTAR',1,ZHOOK_HANDLE)
+END SUBROUTINE CTSTAR
Index: /LMDZ5/branches/testing/libf/phylmd/cv30_routines.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cv30_routines.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/cv30_routines.F90	(revision 2408)
@@ -733,8 +733,8 @@
     iflag, nk, icb, icbs, plcl, tnk, qnk, gznk, pbase, buoybase, t, q, qs, u, &
     v, gz, th, tra, h, lv, cpn, p, ph, tv, tp, tvp, clw, sig, w0)
+  USE print_control_mod, ONLY: lunout
   IMPLICIT NONE
 
   include "cv30param.h"
-  include 'iniprint.h'
 
   ! inputs:
@@ -813,5 +813,5 @@
     WRITE (lunout, *) 'strange! nn not equal to ncum: ', nn, ncum
     abort_message = ''
-    CALL abort_gcm(modname, abort_message, 1)
+    CALL abort_physic(modname, abort_message, 1)
   END IF
 
Index: /LMDZ5/branches/testing/libf/phylmd/cv3_inicp.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cv3_inicp.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/cv3_inicp.F90	(revision 2408)
@@ -109,5 +109,5 @@
       PRINT *, 'WARNING:: AREA OF MIXING PDF IS::', aire
       abort_message = ''
-      CALL abort_gcm(modname, abort_message, 1)
+      CALL abort_physic(modname, abort_message, 1)
     ELSE
       PRINT *, 'Area, mean & std deviation are ::', aire, mu, sigma
Index: /LMDZ5/branches/testing/libf/phylmd/cv3_inip.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cv3_inip.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/cv3_inip.F90	(revision 2408)
@@ -30,9 +30,8 @@
 !----------------------------------------------
 
+  USE print_control_mod, ONLY: prt_level, lunout
   IMPLICIT NONE
 
   include "YOMCST2.h"
-
-  include 'iniprint.h'
 
 !----------------------------------------------
@@ -138,5 +137,5 @@
       WRITE (lunout, *) 'WARNING:: AREA OF MIXING PDF IS::', aire
       abort_message = ''
-      CALL abort_gcm(modname, abort_message, 1)
+      CALL abort_physic(modname, abort_message, 1)
     ELSE
       PRINT *, 'Area, mean & std deviation are ::', aire, mu, sigma
